//+------------------------------------------------------------------+
//|                                             BillWilliams_ATZ.mq4 |
//|                                   Copyright  Arturo Lopez Perez |             
//|           For customizations find me at: flaab.mrlinux@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Arturo Lopez Perez"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#define OP_NOTHING 6

//-------------------------------
// Input parameters: none
//-------------------------------
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern string  Alert_            =  "<<== Alert Setting ==>>";
extern bool    AlertOnCurrent    =  false;
extern int    ArrowsUpCode       = 221;
extern int    ArrowsDnCode       = 222;
extern string  ____Statistics____             =  "<<== Statistical Data ==>>";
 int     ExpiryCandles     =  1;
input ENUM_BASE_CORNER  TextCorner  =  CORNER_LEFT_LOWER;
extern string  TextFont          =  "Arial";
extern int     TextSize          =  16;
extern color   TextColor         =  Silver;

//-------------------------------
// Buffers
//-------------------------------
double arr_up[];
double arr_dn[];
string indicatorFileName;
bool   returnBars;



//-------------------------------
// Internal variables
//-------------------------------
int    nShift;   
int gAlertShift = 0;
datetime NewBarCheck;

//--- Statistical...

int gITM = 0, gOTM = 0;

//---

string IID;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   // Buffers and style
    SetIndexStyle(0, DRAW_ARROW, 0, 1);
    SetIndexArrow(0, ArrowsUpCode);
    SetIndexBuffer(0, arr_up);
    SetIndexStyle(1, DRAW_ARROW, 0, 1);
    SetIndexArrow(1, ArrowsDnCode);
    SetIndexBuffer(1, arr_dn);

    // Data window
    IndicatorShortName("Bill Williams ATZ");
    SetIndexLabel(0, "Buy arrow");
    SetIndexLabel(1, "Sell arrow"); 
    
       gAlertShift = 1;
   if(AlertOnCurrent) gAlertShift = 0;
     //---
   
   NewBarCheck = 0;
   IID = "fct_Indy_";
   //----

   
    // Chart offset calculation
    switch(Period())
    {
        case     1: nShift = 1;   break;    
        case     5: nShift = 3;   break; 
        case    15: nShift = 5;   break; 
        case    30: nShift = 10;  break; 
        case    60: nShift = 15;  break; 
        case   240: nShift = 20;  break; 
        case  1440: nShift = 80;  break; 
        case 10080: nShift = 100; break; 
        case 43200: nShift = 200; break;               
    }
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame==-99);
      TimeFrame         = MathMax(TimeFrame,_Period);

    return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();

    // check for possible errors
    if(counted_bars < 0) 
        return(-1);

   //last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
           if (returnBars)  { arr_up[0] = limit+1; return(0); }
           if (TimeFrame!=_Period)
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit;i>=0;i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  int x = iBarShift(NULL,TimeFrame,Time[i+1]);
                  if (y!=x)
                  {
                     arr_up[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",AlertOnCurrent,ArrowsUpCode,ArrowsDnCode,"",TextCorner,TextFont,TextSize,TextColor,0,y);
                     arr_dn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",AlertOnCurrent,ArrowsUpCode,ArrowsDnCode,"",TextCorner,TextFont,TextSize,TextColor,1,y);
                  }
                  else
                  {
                     arr_up[i] = EMPTY_VALUE;
                     arr_dn[i] = EMPTY_VALUE;
                  }                     
               } 
               return(0);
           }
    // Check the signal foreach bar
    int j;
    for(i = 0; i < limit; i++)
    {
        // SMA
        double MA = iMA(Symbol(), 0, 10, 0, MODE_SMA, PRICE_CLOSE, i);
        
        // Indicate the trend
        int ma_trend = OP_NOTHING;
        int a_trend = OP_NOTHING;
        
        // Bill williams zonetrade indicators to point detect early strenght
        int tz = tradezone(i);
        int tz1 = tradezone(i+1);
        
        // Open and close of the current candle to filter tz signals
        double CLOSE = iClose(Symbol(),0, i);
        double OPEN = iOpen(Symbol(),0, i);
        double HIGH = iHigh(Symbol(),0, i);
        double LOW = iLow(Symbol(),0, i);
        
        // Macd present and past
        double MACD_main = iCustom(Symbol(), 0, "2line_macd", 0, i);
        double MACD_signal = iCustom(Symbol(), 0, "2line_macd", 1, i);
        double MACD_main_last = iCustom(Symbol(), 0, "2line_macd", 0, i+1);
        double MACD_signal_last = iCustom(Symbol(), 0, "2line_macd", 1, i+1);
        
        // Alligator
        double a_jaw = iAlligator(Symbol(), 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, i);
        double a_teeth = iAlligator(Symbol(), 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, i);
        double a_lips = iAlligator(Symbol(), 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, i);
        
        // Calculate alligator trend
        if(a_lips > a_teeth && a_teeth > a_jaw)
            a_trend = OP_BUY;
        else if(a_lips < a_teeth && a_teeth < a_jaw)
            a_trend = OP_SELL;
            
        // Evaluate if going long or short is dangerous now
        bool long_dangerous = false;
        bool short_dangerous = false;
        if(CLOSE > a_lips && MACD_main < MACD_signal) long_dangerous = true;
        if(CLOSE < a_lips && MACD_main > MACD_signal) short_dangerous = true;
         
 
          if(
               (tz == OP_BUY && tz1 != OP_BUY && a_trend == OP_BUY && CLOSE > OPEN && long_dangerous == false)       
        )
      {
         arr_up[i]=iLow(Symbol(),0,i)  - nShift*Point;;
              
      }
      else if(
               (tz == OP_SELL && tz1 != OP_SELL && a_trend == OP_SELL && CLOSE < OPEN && short_dangerous == false)  
        )
      {
         arr_dn[i]=iHigh(Symbol(),0,i) +  nShift*Point;;      
             
      }        
   }
   
   static datetime dtlboai11;
   
   if(dtlboai11!=iTime(Symbol(),0,0))
   {
      string stralert;
      if(arr_up[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Long Signal Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName();
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
      else if(arr_dn[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Short Signal Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName();
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
   }
   
      //---
   
   //--- Get statistical data
   
   if(!isNewBar()) return(0);
   gITM = 0; gOTM = 0;
   for(j = 1; j < Bars; j++)
   {
      fnGetITM_OTM(j, gITM, gOTM);
   }
   
   fnShowInfor();
    return(0);
}
string strtf(int tf)
{
   switch(tf)
   {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN1");
      default:return("Unknown timeframe");
   }
}
/**
* Returns bill williams trade zone for the candle received has parameter.
* @param    int   shift
* @return   int
*/

int tradezone(int shift = 1)
{
   // AC and AO for current and last candle
   double AC = iAC(Symbol(), 0, shift);
   double AC_last = iAC(Symbol(), 0, shift+1);
   double AO = iAO(Symbol(), 0, shift);
   double AO_last = iAO(Symbol(), 0, shift+1);
   
   // Returns action for this candle
   if(AO < AO_last && AC < AC_last) return(OP_SELL);
   if(AO > AO_last && AC > AC_last) return(OP_BUY);
   return(OP_NOTHING);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void fnGetITM_OTM(int pShift, int &pITM, int &pOTM)
{
   int lExpiryStart = pShift ;
   int lExpiryEnd = pShift ;
   if(lExpiryEnd <= 0) return;
   //
   if(arr_up[pShift] != EMPTY_VALUE && arr_dn[pShift] != EMPTY_VALUE) return;   
   if(arr_up[pShift] != EMPTY_VALUE)
   {
      if(Open[lExpiryStart] < Close[lExpiryEnd]) pITM++;
      else pOTM++;
   }
   else
   if(arr_dn[pShift] != EMPTY_VALUE)
   {
      if(Open[lExpiryStart] > Close[lExpiryEnd]) pITM++;
      else pOTM++;
   }
}

//+------------------------------------------------------------------+

bool isNewBar()
{   
   bool NewBar = false;
   if (NewBarCheck != iTime(NULL, 0, 0))
   {
      NewBarCheck = iTime(NULL, 0, 0);
      NewBar = true;
   }  
   return (NewBar);
}

//+------------------------------------------------------------------+

void fnShowInfor()
{
   int iX, iY;
   int lXDist = 40;
   //
   if(TextCorner == CORNER_LEFT_LOWER) iY = 60;
   else iY = 30;
   iX = 10; 
   fnDrawLabel(IID + "ITM_", iX, iY, "ITM", TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "OTM_", iX, iY, "OTM", TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "IOTM_", iX, iY, "Percent", TextSize, TextFont, TextColor, TextCorner);
   //
   if(TextCorner == CORNER_LEFT_LOWER) iY -= 30;
   else iY += 30;
   iX = 10;
   fnDrawLabel(IID + "ITMV_", iX, iY, DoubleToStr(gITM, 0), TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   fnDrawLabel(IID + "OTMV_", iX, iY, DoubleToStr(gOTM, 0), TextSize, TextFont, TextColor, TextCorner);
   iX += lXDist + TextSize;
   if(gOTM + gITM > 0)
      fnDrawLabel(IID + "IOTMV_", iX, iY, DoubleToStr(gITM*100/(gOTM + gITM), 2), TextSize, TextFont, TextColor, TextCorner);
   else
      fnDrawLabel(IID + "IOTMV_", iX, iY, "N/A", TextSize, TextFont, TextColor, TextCorner);
   ChartRedraw(ChartID());
}

//+------------------------------------------------------------------+


void fnDrawLabel(string iName, int iX, int iY, string iText, int iFontSize, string iFontName, color iColor, int iCorner = 0)
{
   if(ObjectFind(iName < 0)) ObjectCreate(ChartID(), iName, OBJ_LABEL, ChartWindowFind(), 0, 0);
   ObjectSetInteger(ChartID(), iName, OBJPROP_CORNER, iCorner);
   //ObjectSetInteger(ChartID(), iName, OBJPROP_ANCHOR, ANCHOR_LEFT_UPPER);
   ObjectSet(iName, OBJPROP_BACK, FALSE);
   ObjectSet(iName, OBJPROP_XDISTANCE, iX);
   ObjectSet(iName, OBJPROP_YDISTANCE, iY);
   ObjectSetText(iName, iText, iFontSize, iFontName, iColor);
}

//---

void fnDeleteAllObj()
{
   string lookFor = IID;
   string objectName;
   int lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal()-1; i >= 0; i--)
   {
      objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

